def proc draw_entire_puzzle(level%,size%)
  set_sizes level%,size%
  draw_puzzle puzzle_size%,mnch%,"",0
end def draw_entire_puzzle
:
def proc draw_puzzle(msize%,chan%,to_draw$,erase%)
local lp%,a$,ys%,b$
  ys%=current_level%(1)                 : rem nbr of rows in this level
  xs%=current_level%(0)                 : rem nbr of cols per row
  yo%=puzzle_yorig%
  for lp%=1 to ys%
    a$=current_level$(lp%)              : rem get one row
    if a$="":exit lp%                   : rem done
    xo%=puzzle_xorig%-msize%                         : rem start painting row here
    for lp2%=1 to len(a$)
      xo%=xo%+msize%
      b$=a$(lp2%)
      if to_draw$<>"" and b$<>to_draw$:next lp2%:exit lp2%
      if b$=" "
        block#chan%,msize%,msize%,xo%,yo%,paper_col
        next lp2%:exit lp2%
      endif
      if b$="."
        block#chan%,msize%,msize%,xo%,yo%,paper_col
        block#chan%,msize%-2,msize%-2,xo%+1,yo%+1,target_col
        next lp2%:exit lp2%
      endif
      if b$="-"
        block#chan%,msize%,msize%,xo%,yo%,paper_col
        block#chan%,msize%-2,msize%-2,xo%+1,yo%+1,exit_col
        next lp2%:exit lp2%
      endif
      rem if we get here, it's (part of) a tile
      if b$="#"
        block#chan%,msize%,msize%,xo%,yo%,wall_col
      else
        if erase%
            if targets%(lp%,lp2%)=1
                rem is target, redraw target
                block#chan%,msize%,msize%,xo%,yo%,paper_col
                block#chan%,msize%-2,msize%-2,xo%+1,yo%+1,target_col
            else
              if targets%(lp%,lp2%)=2
                block#chan%,msize%,msize%,xo%,yo%,paper_col
                block#chan%,msize%-2,msize%-2,xo%+1,yo%+1,exit_col
                rem redraw opening
              else
                block#chan%,msize%,msize%,xo%,yo%,paper_col
              endif
            endif
            next lp2%:exit lp2%
        else
          block#chan%,msize%,msize%,xo%,yo%,tile_col
          if b$="*"
            block#chan%,2,2,xo%+(msize%-2) div 2,yo%+(msize%-2) div 2,boder_col
          endif
        endif
      endif
      paint_edges lp2%,lp%,xo%,yo%
    end for lp2%
    yo%=yo%+msize%
  end for lp%
end def draw_puzzle
:
def proc paint_edges(col%,row%,xo%,yo%)
rem paint the edges of a tile if the tile next to it is NOT the same.
rem level%,ys%,xs%,chan%,b$ are from caller
local up%,down%,left%,right%
:
  upper%=0:lower%=0:left%=0:right%=0
  rem check upper
  if row%=1
    upper%=1
  else
    if current_level$(row%-1,col%)<>b$:upper%=1
  endif
  rem check lower
  if row%=ys%
    lower%=1
  else
    if current_level$(row%+1,col%)<>b$:lower%=1
  endif
 rem check left
  if col%=1
    left%=1
  else
    if current_level$(row%,col%-1)<>b$:left%=1
  endif
 rem check right
  if col%=xs%
    right%=1
  else
    if current_level$(row%,col%+1)<>b$:right%=1
  endif
  if upper%
    block#chan%,msize%,1,xo%,yo%,paper_col
    block#chan%,msize%-left%-right%,1,xo%+left%,yo%+1,border_col
  endif
  if lower%
    block#chan%,msize%,1,xo%,yo%+msize%-1,paper_col
    block#chan%,msize%-left%-right%,1,xo%+left%,yo%+msize%-2,border_col
  endif
  if right%
    block#chan%,1,msize%,xo%+msize%-1,yo%,paper_col
    block#chan%,1,msize%-upper%-lower%,xo%+msize%-2,yo%+upper%,border_col
  endif
  if left%
    block#chan%,1,msize%,xo%,yo%,paper_col
    block#chan%,1,msize%-upper%-lower%,xo%+1,yo%+upper%,border_col
  endif
end def paint_edges
:
